; 

    WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
    WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    PDH_MAX_COUNTER_PATH    equ 2048
    PDH_FMT_LONG            equ 000000100h
    PDH_CSTATUS_VALID_DATA  equ 0

    IDI_TASKBARICON         equ 0
    WM_CALLBACK             equ WM_USER + 100
    IDM_EXIT                equ 1000
    ID_TIMER                equ 1

    PDH_COUNTER_PATH_ELEMENTS STRUCT
      szMachineName       DWORD ?
      szObjectName        DWORD ?
      szInstanceName      DWORD ?
      szParentInstance    DWORD ?
      dwInstanceIndex     DWORD ?
      szCounterName       DWORD ?
    PDH_COUNTER_PATH_ELEMENTS ENDS

    PDH_FMT_COUNTERVALUE STRUCT
      CStatus             DWORD ?
      padding             DWORD ?
      UNION
        longValue         DWORD ?
        doubleValue       REAL8 ?
        largeValue        QWORD ?
        AnsiStringValue   DWORD ?
        WideStringValue   DWORD ?
      ENDS
    PDH_FMT_COUNTERVALUE ENDS

; 

    .data?

      commandLine   dd ?

      hInstance     dd ?
      hWnd          dd ?
      hPopupMenu    dd ?

      hIcon000      dd ?
      hIcon025      dd ?
      hIcon050      dd ?
      hIcon075      dd ?
      hIcon100      dd ?

      nSize         dd ?
      hQuery        dd ?
      hCounter      dd ?
      prevValue     dd ?

      pcpe          PDH_COUNTER_PATH_ELEMENTS <>
      pfc           PDH_FMT_COUNTERVALUE <>

      nid           NOTIFYICONDATA <>

    .data

      queryCount    dd 0
      queryTotal    dd 0

      className     db "HddActivityMonitorClass",0
      windowName    db " HDD Activity Monitor ",0
       
      machineName   db MAX_COMPUTERNAME_LENGTH + 1 dup(0)
      objectName    db "PhysicalDisk",0
      counterName   db "% Disk Time",0
      instanceName  db "_Total",0
      counterPath   db PDH_MAX_COUNTER_PATH dup(0)

; 
